/*
 * Ostatnia aktualizacja:
 * 
 * - $Id: groupchat.c,v 1.6 2002/11/25 18:20:49 mati Exp $
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

#include "libtlen.h"

/*
 * tlen_groupchat_init()
 *
 * Inicjuje konferencj
 *
 * - sesja - nasza sesja
 * - to - uytkownik z ktrym chcemy konferowa
 *
 * Niezaimplementowana obsuga konferencji, funkcja testowa!
 *
 */

int tlen_groupchat_init(struct tlen_session *sesja, char *to)
{
    char *query;

    tlen_debug("Initiating groupchat with %s\n",to);
    
    if (!(query = (char *) malloc (strlen("<presence to='@conf'/><iq to='@conf' type='set' id='groupchatregister'><query xmlns='jabber:iq:conference'><nick></nick><secret>542632</secret></query></iq><message to=''><subject>g</subject><body>%3A542632</body></message>") + 5 /* dlugosc maks sekund */ + 5 /* dlugosc maks sekund */ + 5 /* dlugosc maks sekund */ + strlen(sesja->username) + strlen(sesja->username) + strlen(sesja->username) + strlen(sesja->username) + strlen(to))))
    {
	perror("malloc");
	sesja->error = TLEN_ERROR_MALLOC;    
    }

    sprintf (query, "<presence to='%s%d@conf'/><iq to='%s%d@conf' type='set' id='groupchatregister'><query xmlns='jabber:iq:conference'><nick>%s</nick><secret>542632</secret></query></iq><message to='%s'><subject>g</subject><body>%s%d%s542632</body></message>", sesja->username, tlen_get_second(), sesja->username, tlen_get_second(), sesja->username, to, sesja->username, tlen_get_second(),"%3A");
    
    tlen_socket_write_string (sesja, query);
    free(query);
    return 1;
}


/* 
 * tlen_get_second()
 *
 * Zwraca sekund danego dnia
 *
 * - brak parametrw
 *
 * Potrzebna przy zapytaniach konferencyjnych
 *
 */

int tlen_get_second()
{
    int sec;
    time_t t;
    struct tm *tm;
    
    t = time(NULL);
    tm = localtime(&t);
    sec = tm->tm_sec + (tm->tm_min*60) + ((tm->tm_hour*60)*60);
    
    return sec;
}    
